Index: trunk/gui/scripts/field.tcl
===================================================================
--- trunk/gui/scripts/field.tcl	(revision 6716)
+++ trunk/gui/scripts/field.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: field - extracts data from an XML description of a field
@@ -8,157 +7,34 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
-
-# TODO:
-#    Vector field limits are wrong: need to compute magnitude limits and
-#    component-wise limits.
-
-#
-# Possible field dataset types:
-#
-# 1D Datasets
-#       1D              A field contained in a structure
-# 2D Datasets
-#       vtk             (range of z-axis is zero).
-#       unirect2d       (deprecated)
-#       cloud           (x,y point coordinates) (deprecated)
-#       mesh
-# 3D Datasets
-#       vtk
-#       unirect3d       (deprecated)
-#       cloud           (x,y,z coordinates) (deprecated)
-#       mesh
-#       dx              (FIXME: make dx-to-vtk converter work)
-#       ucd             (AVS ucd format)
-#
-# Viewers:
-#       Format     Dim  Description                   Viewer          Server
-#       1D          1   structure field               DeviceViewer1D  N/A
-#       vtk         2   vtk file data.                contour         vtkvis
-#       vtk         3   vtk file data.                isosurface      vtkvis
-#       mesh        2   points-on-mesh                heightmap       vtkvis
-#       mesh        3   points-on-mesh                isosurface      vtkvis
-#       dx          3   DX                            volume          nanovis
-#       unirect2d   2   unirect2d + extents > 1 flow  flow            nanovis
-#       unirect3d   3   unirect3d + extents > 1 flow  flow            nanovis
-#
-# With <views>, can specify which viewer for specific datasets.  So it's OK
-# for the same dataset to be viewed in more than one way.
-#  o Any 2D dataset can be viewed as a contour/heightmap.
-#  o Any 3D dataset can be viewed as a isosurface.
-#  o Any 2D dataset with vector data can be streamlines or flow.
-#  o Any 3D uniform rectilinear dataset can be viewed as a volume.
-#  o Any 3D dataset with vector data can be streamlines or flow.
-#
-# Need <views> to properly do things like qdot: volume with a polydata
-# transparent shell.  The view will combine the two objects <field> and
-# <drawing> (??) into a single viewer.
-#
 package require Itcl
 package require BLT
 
-namespace eval Rappture {
-    # forward declaration
-}
+namespace eval Rappture { # forward declaration }
 
 itcl::class Rappture::Field {
-    constructor {xmlobj path} {
-        # defined below
-    }
-    destructor {
-        # defined below
-    }
-    public method blob { cname }
-    public method components {args}
+    constructor {devobj libobj path} { # defined below }
+    destructor { # defined below }
+
+    public method components {{pattern *}}
+    public method vectors {{what -overall}}
     public method controls {option args}
-    public method fieldinfo { fname } {
-        lappend out $_fld2Label($fname)
-        lappend out $_fld2Units($fname)
-        lappend out $_fld2Components($fname)
-        return $out
-    }
-    public method fieldlimits {}
-    public method fieldnames { cname } {
-        if { ![info exists _comp2fldName($cname)] } {
-            return ""
-        }
-        return $_comp2fldName($cname)
-    }
-    public method flowhints { cname }
     public method hints {{key ""}}
-    public method isvalid {} {
-        return $_isValid
-    }
-    public method limits {axis}
-    public method mesh {{cname -overall}}
-    public method numComponents {cname}
-    public method style { cname }
-    public method type {}
-    public method valueLimits { cname }
-    public method values { cname }
-    public method viewer {} {
-        return $_viewer
-    }
-    public method vtkdata {cname}
-    public method xErrorValues { cname } {
-    }
-    public method yErrorValues { cname } {
-    }
-
-    protected method Build {}
-    protected method _getValue {expr}
-    protected method GetAssociation { cname }
-    protected method GetTypeAndSize { cname }
-    protected method ReadVtkDataSet { cname contents }
-
-    private method AvsToVtk { cname contents }
-    private method DicomToVtk { cname contents }
-    private method BuildPointsOnMesh { cname }
-    private method InitHints {}
-    private method VerifyVtkDataSet { contents }
-    private method VectorLimits { vector vectorsize {comp -1} }
-    private method VtkDataSetToXy { dataset }
-
-    protected variable _dim 0;          # Dimension of the mesh
-
-    private variable _xmlobj "";        # ref to XML obj with field data
-    private variable _path "";          # Path of this object in the XML
-    private variable _field "";         # This field element as XML obj
-
-    private variable _type "";          # Field type: e.g. file type
-    private variable _hints;            # Hints array
-    private variable _limits;           # maps axis name => {z0 z1} limits
-    private variable _units "";         # system of units for this field
-    private variable _viewer "";        # Hints which viewer to use
-    private variable _isValid 0;        # Indicates if the field contains
-                                        # valid data.
-    private variable _isValidComponent; # Array of valid components found
-    private variable _zmax 0;           # length of the device (1D only)
-
-    private variable _fld2Components;   # field name => number of components
-    private variable _fld2Label;        # field name => label
-    private variable _fld2Units;        # field name => units
-
-    private variable _comp2fldName;     # cname => field names.
-    private variable _comp2type;        # cname => type (e.g. "vectors")
-    private variable _comp2size;        # cname => # of components in element
-    private variable _comp2assoc;       # cname => association (e.g. pointdata)
-    private variable _comp2dims;        # cname => dimensionality
-    private variable _comp2xy;          # cname => x,y vectors
-    private variable _comp2vtk;         # cname => vtk file data
-    private variable _comp2dx;          # cname => OpenDX data
-    private variable _comp2style;       # cname => style settings
-    private variable _comp2cntls;       # cname => x,y control points (1D only)
-    private variable _comp2limits;      # cname => List of axis, min/max list
-    private variable _comp2flowhints;   # cname => Rappture::FlowHints obj
-    private variable _comp2mesh;        # list: mesh obj, BLT vector of values
-                                        # valid for cloud,mesh,unirect2d
-    private common _alwaysConvertDX 0;  # If set, convert DX and store as VTK,
-                                        # even if viewer is nanovis/flowvis
-    private common _counter 0;          # counter for unique vector names
+
+    protected method _build {}
+
+    private variable _device ""  ;# ref to lib obj with device data
+    private variable _libobj ""  ;# ref to lib obj with field data
+
+    private variable _units ""   ;# system of units for this field
+    private variable _limits     ;# maps slab name => {z0 z1} limits
+    private variable _zmax 0     ;# length of the device
+
+    private variable _field ""   ;# lib obj representing this field
+    private variable _comp2vecs  ;# maps component name => x,y vectors
+    private variable _comp2cntls ;# maps component name => x,y control points
+
+    private common _counter 0    ;# counter for unique vector names
 }
 
@@ -166,36 +42,31 @@
 # CONSTRUCTOR
 # ----------------------------------------------------------------------
-itcl::body Rappture::Field::constructor {xmlobj path} {
-    package require vtk
-    if {![Rappture::library isvalid $xmlobj]} {
-        error "bad value \"$xmlobj\": should be Rappture::library"
-    }
-    set _xmlobj $xmlobj
-    set _path $path
-    set _field [$xmlobj element -as object $path]
+itcl::body Rappture::Field::constructor {devobj libobj path} {
+    if {![Rappture::Library::valid $devobj]} {
+        error "bad value \"$devobj\": should be LibraryObj"
+    }
+    if {![Rappture::Library::valid $libobj]} {
+        error "bad value \"$libobj\": should be LibraryObj"
+    }
+    set _device $devobj
+    set _libobj $libobj
+    set _field [$libobj get -object $path]
     set _units [$_field get units]
-
-    set xunits [$xmlobj get units]
-    if {"" == $xunits || "arbitrary" == $xunits} {
-        set xunits "um"
-    }
 
     # determine the overall size of the device
     set z0 [set z1 0]
-    foreach elem [$_xmlobj children components] {
+    foreach elem [$_device get -children recipe] {
         switch -glob -- $elem {
-            box* {
+            slab* - molecule* {
                 if {![regexp {[0-9]$} $elem]} {
                     set elem "${elem}0"
                 }
-                set z0 [$_xmlobj get components.$elem.corner0]
-                set z0 [Rappture::Units::convert $z0 \
-                    -context $xunits -to $xunits -units off]
-
-                set z1 [$_xmlobj get components.$elem.corner1]
-                set z1 [Rappture::Units::convert $z1 \
-                    -context $xunits -to $xunits -units off]
-
+                set tval [$_device get recipe.$elem.thickness]
+                set tval [Rappture::Units::convert $tval \
+                    -context um -to um -units off]
+                set z1 [expr {$z0+$tval}]
                 set _limits($elem) [list $z0 $z1]
+
+                set z0 $z1
             }
         }
@@ -204,6 +75,5 @@
 
     # build up vectors for various components of the field
-    Build
-    InitHints
+    _build
 }
 
@@ -213,78 +83,23 @@
 itcl::body Rappture::Field::destructor {} {
     itcl::delete object $_field
-    # don't destroy the _xmlobj! we don't own it!
-
-    foreach name [array names _comp2xy] {
-        eval blt::vector destroy $_comp2xy($name)
-    }
-    foreach name [array names _comp2flowhints] {
-        itcl::delete object $_comp2flowhints($name)
-    }
-    foreach name [array names _comp2mesh] {
-        # Data is in the form of a mesh and a vector.
-        foreach { mesh vector } $_comp2mesh($name) break
-        # Release the mesh (may be shared)
-        set class [$mesh info class]
-        ${class}::release $mesh
-        # Destroy the vector
-        blt::vector destroy $vector
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: components ?-name|-dimensions|-style? ?<pattern>?
-#
-# Returns a list of names or types for the various components of
-# this field.  If the optional glob-style <pattern> is specified,
-# then it returns only the components with names matching the pattern.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::components {args} {
-    Rappture::getopts args params {
-        flag what -name default
-        flag what -dimensions
-        flag what -style
-        flag what -particles
-        flag what -flow
-        flag what -box
-    }
-
-    set pattern *
-    if {[llength $args] > 0} {
-        set pattern [lindex $args 0]
-        set args [lrange $args 1 end]
-    }
-    if {[llength $args] > 0} {
-        error "wrong # args: should be \"components ?switches? ?pattern?\""
-    }
-
-    # There's only one dimension of the field.  Components can't have
-    # different dimensions in the same field.  They would by definition be
-    # using different meshes and viewers.
-    if { $params(what) == "-dimensions" } {
-        return "${_dim}D"
-    }
-    # BE CAREFUL: return component names in proper order
+    # don't destroy the _device! we don't own it!
+
+    foreach name [array names _comp2vecs] {
+        eval blt::vector destroy $_comp2vecs($name)
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: components ?<pattern>?
+#
+# Returns a list of names for the various components of this field.
+# If the optional glob-style <pattern> is specified, then it returns
+# only the component names matching the pattern.
+# ----------------------------------------------------------------------
+itcl::body Rappture::Field::components {{pattern *}} {
     set rlist ""
-    set components {}
-    # First compile a list of valid components that match the pattern
-    foreach cname [$_field children -type component] {
-        if { ![info exists _isValidComponent($cname)] } {
-            continue
-        }
-        if { [string match $pattern $cname] } {
-            lappend components $cname
-        }
-    }
-    # Now handle the tests.
-    switch -- $params(what) {
-        -name {
-            set rlist $components
-        }
-        -style {
-            foreach cname $components {
-                if { [info exists _comp2style($cname)] } {
-                    lappend rlist $_comp2style($cname)
-                }
-            }
+    foreach name [array names _comp2vecs] {
+        if {[string match $pattern $name]} {
+            lappend rlist $name
         }
     }
@@ -293,254 +108,19 @@
 
 # ----------------------------------------------------------------------
-# USAGE: mesh ?<name>?
-#
-# For 1D data (curve), returns a BLT vector of x values for the field
-# component <name>.  Otherwise, this method is unused.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::mesh {{cname -overall}} {
-    if {$cname == "-overall" || $cname == "component0"} {
-        set cname [lindex [components -name] 0]
-    }
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 0]  ;# return xv
-    }
-    if {[info exists _comp2vtk($cname)]} {
-        error "method \"mesh\" is not implemented for VTK file data"
-    }
-    if {[info exists _comp2dx($cname)]} {
-        error "method \"mesh\" is not implemented for DX file data"
-    }
-    if {[info exists _comp2mesh($cname)]} {
-        error "method \"mesh\" is not implemented for Rappture::Mesh"
-    }
-    error "can't get field mesh: Unknown component \"$cname\": should be one of [join [lsort [array names _comp2dims]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: values ?<name>?
-#
-# For 1D data (curve), returns a BLT vector of field values (y coords)
-# for the field component <name>.  Otherwise, this method is unused.
-# The number of elements in the vector should be a multiple of the
-# return value of [numComponents]
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::values {cname} {
-    if {$cname == "component0"} {
-        set cname "component"
-    }
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 1]  ;# return yv
-    }
-    if {[info exists _comp2vtk($cname)]} {
-        error "method \"values\" is not implemented for VTK file data"
-    }
-    if {[info exists _comp2dx($cname)]} {
-        error "method \"values\" is not implemented for DX file data"
-    }
-    if {[info exists _comp2mesh($cname)]} {
-        return [lindex $_comp2mesh($cname) 1] ;# return vector
-    }
-    error "can't get field values. Unknown component \"$cname\": should be one of [join [lsort [array names _comp2dims]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: blob ?<name>?
-#
-# Returns a string representing the blob of data for the mesh and values.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::blob {cname} {
-    if {$cname == "component0"} {
-        set cname "component"
-    }
-    if {[info exists _comp2dx($cname)]} {
-        return $_comp2dx($cname)  ;# return gzipped, base64-encoded DX data
-    }
-    if {[info exists _comp2mesh($cname)]} {
-        error "method \"blob\" not implemented for Rappture::Mesh"
-    }
-    if {[info exists _comp2vtk($cname)]} {
-        error "method \"blob\" not implemented for VTK file data"
-    }
-    if {[info exists _comp2xy($cname)]} {
-        error "method \"blob\" not implemented for XY data"
-    }
-    error "can't get field blob: Unknown component \"$cname\": should be one of [join [lsort [array names _comp2dims]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: valueLimits <cname>
-#
-# Returns an array for the requested component with a list {min max}
-# representing the limits for each axis.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::valueLimits { cname } {
-    if { [info exists _comp2limits($cname)] } {
-        return $_comp2limits($cname)
-    }
-    return ""
-}
-
-# ----------------------------------------------------------------------
-# USAGE: limits <axis>
-#
-# Returns a list {min max} representing the limits for the specified
-# axis over all components.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::limits {which} {
-    set min ""
-    set max ""
-
-    foreach cname [array names _comp2dims] {
-        switch -- $_comp2dims($cname) {
-            1D {
-                switch -- $which {
-                    x - xlin {
-                        set pos 0; set log 0; set axis x
-                    }
-                    xlog {
-                        set pos 0; set log 1; set axis x
-                    }
-                    y - ylin - v - vlin {
-                        set pos 1; set log 0; set axis y
-                    }
-                    ylog - vlog {
-                        set pos 1; set log 1; set axis y
-                    }
-                    default {
-                        error "bad axis \"$which\": should be x, xlin, xlog, y, ylin, ylog, v, vlin, vlog"
-                    }
-                }
-
-                set vname [lindex $_comp2xy($cname) $pos]
-
-                if {$log} {
-                    blt::vector tmp zero
-                    # on a log scale, use abs value and ignore zeros
-                    $vname dup tmp
-                    $vname dup zero
-                    zero expr {tmp == 0}            ;# find the zeros
-                    tmp expr {abs(tmp)}             ;# get the abs value
-                    tmp expr {tmp + zero*max(tmp)}  ;# replace 0s with abs max
-                    set axisMin [blt::vector expr min(tmp)]
-                    set axisMax [blt::vector expr max(tmp)]
-                    blt::vector destroy tmp zero
-                } else {
-                    set axisMin [$vname min]
-                    set axisMax [$vname max]
-                }
-
-                if {"" == $min} {
-                    set min $axisMin
-                } elseif {$axisMin < $min} {
-                    set min $axisMin
-                }
-                if {"" == $max} {
-                    set max $axisMax
-                } elseif {$axisMax > $max} {
-                    set max $axisMax
-                }
-            }
-            default {
-                if {[info exists _comp2limits($cname)]} {
-                    array set limits $_comp2limits($cname)
-                    switch -- $which {
-                        x - xlin - xlog {
-                            set axis x
-                            foreach {axisMin axisMax} $limits(x) break
-                        }
-                        y - ylin - ylog {
-                            set axis y
-                            foreach {axisMin axisMax} $limits(y) break
-                        }
-                        z - zlin - zlog {
-                            set axis z
-                            foreach {axisMin axisMax} $limits(z) break
-                        }
-                        v - vlin - vlog {
-                            set axis v
-                            foreach {axisMin axisMax} $limits(v) break
-                        }
-                        default {
-                            if { ![info exists limits($which)] } {
-                                error "limits: unknown axis \"$which\""
-                            }
-                            set axis v
-                            foreach {axisMin axisMax} $limits($which) break
-                        }
-                    }
-                } else {
-                    set axisMin 0  ;# HACK ALERT! must be OpenDX data
-                    set axisMax 1
-                    set axis v
-                }
-            }
-        }
-        if { "" == $min || $axisMin < $min } {
-            set min $axisMin
-        }
-        if { "" == $max || $axisMax > $max } {
-            set max $axisMax
-        }
-    }
-    set val [$_field get "${axis}axis.min"]
-    if {"" != $val && "" != $min} {
-        if {$val > $min} {
-            # tool specified this min -- don't go any lower
-            set min $val
-        }
-    }
-    set val [$_field get "${axis}axis.max"]
-    if {"" != $val && "" != $max} {
-        if {$val < $max} {
-            # tool specified this max -- don't go any higher
-            set max $val
-        }
-    }
-    return [list $min $max]
-}
-
-# ----------------------------------------------------------------------
-# USAGE: fieldlimits
-#
-# This method is for use with VTK components that have multiple fields.
-# It really makes no sense to have multiple fields in a field, but this
-# is here until we add a proper dataset object to hold multiple fields.
-#
-# Returns an array mapping fieldname => list {min max} representing the
-# limits over all components for the given fieldname.  This assumes that
-# all components have the same set of fields.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::fieldlimits {} {
-    foreach cname [array names _comp2limits] {
-        array set limits $_comp2limits($cname)
-        foreach fname [fieldnames $cname] {
-            if { ![info exists limits($fname)] } {
-                puts stderr "ERROR: field \"$fname\" unknown in \"$cname\""
-                continue
-            }
-            foreach {min max} $limits($fname) break
-            if { ![info exists overall($fname)] } {
-                set overall($fname) $limits($fname)
-                continue
-            }
-            foreach {omin omax} $overall($fname) break
-            if { $min < $omin } {
-                set omin $min
-            }
-            if { $max > $omax } {
-                set omax $max
-            }
-            set overall($fname) [list $min $max]
-        }
-    }
-    if { [info exists overall] } {
-        return [array get overall]
-    }
-    return ""
+# USAGE: vectors ?<name>?
+#
+# Returns a list {xvec yvec} for the specified field component <name>.
+# If the name is not specified, then it returns the vectors for the
+# overall field (sum of all components).
+# ----------------------------------------------------------------------
+itcl::body Rappture::Field::vectors {{what -overall}} {
+    if {[info exists _comp2vecs($what)]} {
+        return $_comp2vecs($what)
+    }
+    error "bad option \"$what\": should be [join [lsort [array names _comp2vecs]] {, }]"
 }
 
 # ----------------------------------------------------------------------
 # USAGE: controls get ?<name>?
-# USAGE: controls validate <path> <value>
 # USAGE: controls put <path> <value>
 #
@@ -551,74 +131,18 @@
     switch -- $option {
         get {
-            set cname [lindex $args 0]
-            if {[info exists _comp2cntls($cname)]} {
-                return $_comp2cntls($cname)
-            }
-            return ""
-        }
-        validate {
-            set path [lindex $args 0]
-            set value [lindex $args 1]
-            set units [$_xmlobj get $path.units]
-
-            if {"" != $units} {
-                set nv [Rappture::Units::convert \
-                    $value -context $units -to $units -units off]
-            } else {
-                set nv $value
-            }
-            if {![string is double $nv]
-                  || [regexp -nocase {^(inf|nan)$} $nv]} {
-                error "Value out of range"
-            }
-
-            set rawmin [$_xmlobj get $path.min]
-            if {"" != $rawmin} {
-                set minv $rawmin
-                if {"" != $units} {
-                    set minv [Rappture::Units::convert \
-                        $minv -context $units -to $units -units off]
-                    set nv [Rappture::Units::convert \
-                        $value -context $units -to $units -units off]
-                }
-                # fix for the case when the user tries to
-                # compare values like minv=-500 nv=-0600
-                set nv [format "%g" $nv]
-                set minv [format "%g" $minv]
-
-                if {$nv < $minv} {
-                    error "Minimum value allowed here is $rawmin"
-                }
-            }
-
-            set rawmax [$_xmlobj get $path.max]
-            if {"" != $rawmax} {
-                set maxv $rawmax
-                if {"" != $units} {
-                    set maxv [Rappture::Units::convert \
-                        $maxv -context $units -to $units -units off]
-                    set nv [Rappture::Units::convert \
-                        $value -context $units -to $units -units off]
-                }
-                # fix for the case when the user tries to
-                # compare values like maxv=-500 nv=-0600
-                set nv [format "%g" $nv]
-                set maxv [format "%g" $maxv]
-
-                if {$nv > $maxv} {
-                    error "Maximum value allowed here is $rawmax"
-                }
-            }
-
-            return "ok"
+            set what [lindex $args 0]
+            if {[info exists _comp2cntls($what)]} {
+                return $_comp2cntls($what)
+            }
+            error "bad option \"$what\": should be [join [lsort [array names _comp2cntls]] {, }]"
         }
         put {
             set path [lindex $args 0]
             set value [lindex $args 1]
-            $_xmlobj put $path.current $value
-            Build
+            $_field put $path $value
+            _build
         }
         default {
-            error "bad field controls option \"$option\": should be get or put"
+            error "bad option \"$option\": should be get or put"
         }
     }
@@ -633,87 +157,22 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Field::hints {{keyword ""}} {
-    if { $keyword != "" } {
-        if {[info exists _hints($keyword)]} {
-            return $_hints($keyword)
+    foreach key {label scale color units restrict} {
+        set str [$_field get $key]
+        if {"" != $str} {
+            set hints($key) $str
+        }
+    }
+
+    if {$keyword != ""} {
+        if {[info exists hints($keyword)]} {
+            return $hints($keyword)
         }
         return ""
     }
-    return [array get _hints]
-}
-
-
-# ----------------------------------------------------------------------
-# USAGE: InitHints
-#
-# Returns a list of key/value pairs for various hints about plotting
-# this field.  If a particular <keyword> is specified, then it returns
-# the hint for that <keyword>, if it exists.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Field::InitHints {} {
-    # Order of duplicate keys matters here: later entries override
-    # earlier ones.  For example: camera.position is deprecated in
-    # favor of about.camera, so about.camera is listed after
-    # camera.position
-    foreach {key path} {
-        camera          camera.position
-        camera          about.camera
-        color           about.color
-        group           about.group
-        label           about.label
-        scale           about.scale
-        seeds           about.seeds
-        style           about.style
-        type            about.type
-        xlabel          about.xaxis.label
-        ylabel          about.yaxis.label
-        zlabel          about.zaxis.label
-        xunits          about.xaxis.units
-        yunits          about.yaxis.units
-        zunits          about.zaxis.units
-        units           units
-        updir           updir
-        vectors         about.vectors
-    } {
-        set str [$_field get $path]
-        if { "" != $str } {
-            set _hints($key) $str
-        }
-    }
-    foreach cname [components] {
-        if { ![info exists _comp2mesh($cname)] } {
-            continue
-        }
-        set mesh [lindex $_comp2mesh($cname) 0]
-        foreach axis {x y z} {
-            if { ![info exists _hints(${axis}units)] } {
-                set _hints(${axis}units) [$mesh units $axis]
-            }
-            if { ![info exists _hints(${axis}label)] } {
-                set _hints(${axis}label) [$mesh label $axis]
-            }
-        }
-    }
-    foreach {key path} {
-        toolid          tool.id
-        toolname        tool.name
-        toolcommand     tool.execute
-        tooltitle       tool.title
-        toolrevision    tool.version.application.revision
-    } {
-        set str [$_xmlobj get $path]
-        if { "" != $str } {
-            set _hints($key) $str
-        }
-    }
-    # Set toolip and path hints
-    set _hints(path) $_path
-    if { [info exists _hints(group)] && [info exists _hints(label)] } {
-        # pop-up help for each curve
-        set _hints(tooltip) $_hints(label)
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: Build
+    return [array get hints]
+}
+
+# ----------------------------------------------------------------------
+# USAGE: _build
 #
 # Used internally to build up the vector representation for the
